/*
* 32bit vector fill implementation.
*
* function prototype
* void fr32_vector_fill(
*        const fract32 a,
*        fract32 b[],
*        int count);
*
* parameters
*   FP+16	R2  count
*	FP+12	R1	const fr32 b[]
*	FP+ 8	R0	const fr32 a
*
* return
*	none
*
* side effect
*   out[] : obtain output data
*

* register layout
*	P1 : count : loop counter's initial value
*	I1 : b
*   R0 : a
*/

	.text
	.align 4
	.global _fr32_vector_fill;
	.type _fr32_vector_fill, STT_FUNC;

_fr32_vector_fill:
	link	0;

		/* Set up registers */
	i1 = r1;				// load b
	p1 = R2;				// load count

		/* outer loop */

	loop count lc0 = p1;
	loop_begin count;
		[i1++] = r0;
	loop_end count;
		/* end of outer loop */


	unlink;
	rts;
	.size	_fr32_vector_fill, .-_fr32_vector_fill
