/*
* 32bit vector negate implementation.
*
* function prototype
* void fr32_vector_neg(
*        const fract32 a[],
*        fract32 b[],
*        int count);
*
* parameters
*   FP+16	R2  count
*	FP+12	R1	const fr32 b[]
*	FP+ 8	R0	const fr32 a[]
*
* return
*	none
*
* side effect
*   out[] : obtain output data
*

* register layout
*	P1 : count : loop counter's initial value
*   I0 : a
*	I1 : b
*   R0 : a[i]
*   R1 : -a[i]
*/

	.text
	.align 4
	.global _fr32_vector_neg;
	.type _fr32_vector_neg, STT_FUNC;

_fr32_vector_neg:
	link	0;

		/* Set up registers */
	i0 = r0;				// load a
	i1 = r1;				// load b
	p1 = R2;				// load count
	p1 += -1;

		/* outer loop */
		r0 = [i0++];

	loop count lc0 = p1;	// Todo : can be 3 parallel instruction. But seems to be simulator bug in 2013RC1RC
	loop_begin count;
		r1 = - r0(s) ;
		r0 = [i0++] || [i1++] = r1
	loop_end count;
		r1 = - r0(s) ;
		[i1++] = r1;
		/* end of outer loop */


	unlink;
	rts;
	.size	_fr32_vector_neg, .-_fr32_vector_neg

